program OpticalFlowNo1;

{$APPTYPE CONSOLE}
{$POINTERMATH ON}
{$R *.res}

uses
  windows,
  System.SysUtils,
  ocv.highgui_c,
  ocv.core_c,
  ocv.core.types_c,
  ocv.imgproc_c,
  ocv.imgproc.types_c,
  ocv.tracking_c;

const
  COUNT         = 300;
var
  storage       : pCvMemStorage = nil;
  capture       : pCvCapture    = nil;
  frame         : pIplImage     = nil;
  frame_grey    : pIplImage     = nil;
  oldframe_grey : pIplImage     = nil;
  displayframe  : pIplImage     = nil;
  criteria      : TCvTermCriteria;
  i             : integer;

  prev_pyramid  : pIplImage     = nil;
  curr_pyramid  : pIplImage     = nil;
  corners1      : pCvPoint2D32f;
  corners2      : pCvPoint2D32f;
  corner_count  : integer       = COUNT;
  status        : pcvchar;
  eig_img       : pIplImage     = nil;
  temp_img      : pIplImage     = nil;

  defx, defy    : integer;
  stn           : double;

  key           : integer;
  first         : boolean       = true;
  s             : char;
  AHnd : THandle;
begin
  try
    // Jɐڑ
    capture    := cvCreateCameraCapture(0);
    // ڑłȂI R\[[h̃L[͐ݒ
    if not Assigned(capture) then begin
      AHnd := GetStdHandle(STD_INPUT_HANDLE);
      SetConsoleMode(AHnd, 0);
      Writeln('>Jɐڑł܂ł@L[ĂB');
      Write('>');
      read(s);
      Halt(integer(s));
    end;
    // 摜̃TCYݒ JɂĒlC܂
    cvSetCaptureProperty(Capture, CV_CAP_PROP_FRAME_WIDTH, 320);
    cvSetCaptureProperty(Capture, CV_CAP_PROP_FRAME_HEIGHT, 240);
    storage    := cvCreateMemStorage(0);
    // frame  擾܂ő҂܂
    i := 0;
    while frame = nil do begin
      frame := cvQueryFrame(capture);
      inc(i);
      if i > 100 then begin
        cvReleaseMemStorage(storage);
        cvReleaseCapture(capture);
        Halt(1);
      end;
    end;

    Writeln('>摜\ʂI@ESC L[ŏI܂B');
    // grey摜̈m
    frame_grey := cvCreateImage(cvSize(frame.width, frame.height), IPL_DEPTH_8U, 1);

    // ړxNgi[\̂̊mہC
    criteria := cvTermCriteria(CV_TERMCRIT_ITER or CV_TERMCRIT_EPS, 20, 0.03);
    corners1 := cvAlloc(corner_count * sizeof(CvPoint2D32f(0, 0)));
    corners2 := cvAlloc(corner_count * sizeof(CvPoint2D32f(0, 0)));
    prev_pyramid := cvCreateImage(cvSize(frame_grey.width + 8, frame_grey.height div 3), IPL_DEPTH_8U, 1);
    curr_pyramid := cvCreateImage(cvSize(frame_grey.width + 8, frame_grey.height div 3), IPL_DEPTH_8U, 1);
    eig_img := cvCreateImage(cvGetSize(frame_grey), IPL_DEPTH_32F, 1);
    temp_img := cvCreateImage(cvGetSize(frame_grey), IPL_DEPTH_32F, 1);
    status := cvAlloc(corner_count);

    while true do
    begin
      // J摜̎擾
      frame := cvQueryFrame(capture);
      // 擾łȂI
      if frame = nil then
        break;
      // O[ϊ
      cvCvtColor(frame, frame_grey, CV_RGB2GRAY);
      // ŏ̂ݎs
      if first then
      begin
        Writeln('>Optical flaw start');
        // N[̍쐬 ̈mەsv
        oldframe_grey  := cvCloneImage(frame_grey);
        displayframe   := cvCloneImage(frame_grey);
        // greyC[W̃Rs[
        cvConvertScale(frame_grey, oldframe_grey, 1.0, 0.0);
        first := false;
      end;
      // 摜̃Rs[ {
      cvConvertScale(frame_grey, displayframe, 1.0, 0.0);
      // corner_count̒l@ꍇ̂ōĐݒ肵܂
      corner_count := COUNT;
      // aȓ_o
      cvGoodFeaturesToTrack(oldframe_grey, eig_img, temp_img, corners1, @corner_count, 0.001, 5, nil, 3, 0, 0.04);
//      cvGoodFeaturesToTrack(oldframe_grey, eig_img, temp_img, corners1, @corner_count, 0.001, 5, nil);
//      cvFindCornerSubPix(oldframe_grey, corners1, corner_count, cvSize(5, 5), cvSize(-1, -1), criteria);

      // IveBJt[vZiLKj
      cvCalcOpticalFlowPyrLK(oldframe_grey, frame_grey, prev_pyramid, curr_pyramid, corners1, corners2, corner_count,
          cvSize (10, 10), 4, status, nil, criteria, 0);

      // vZꂽt[`iLKj
      for i := 0 to corner_count - 1 do
        if status[i] = #1 then
        begin
          // ړ̐ mCY C`
          defx := (cvPointFrom32f(corners1[i]).x - cvPointFrom32f(corners2[i]).x);
          defy := (cvPointFrom32f(corners1[i]).y - cvPointFrom32f(corners2[i]).y);
          stn := sqrt(defx * defx + defy * defy);
          if stn < 30 then
            cvLine (displayframe, cvPointFrom32f(corners1[i]), cvPointFrom32f(corners2[i]), CV_RGB (255, 255, 255), 1, 0);
        end;
      // IveBJt[̕\
      cvShowImage('Input Image', frame);
      cvShowImage('Optical Flow Image', displayframe);
      // V摜Â摜փRs[
      cvConvertScale(frame_grey, oldframe_grey, 1.0, 0.0);
      cvClearMemStorage(storage);
      // escL[ŏI
      key := cvWaitKey(18);
      if (key = 27) then
        break;
    end;
    // [̉
    cvReleaseMemStorage(storage);
    cvReleaseCapture(capture);
    cvReleaseImage(oldframe_grey);
    cvReleaseImage(frame_grey);
    cvReleaseImage(prev_pyramid);
    cvReleaseImage(curr_pyramid);
    cvReleaseImage(eig_img);
    cvReleaseImage(temp_img);
    cvReleaseImage(displayframe);

    cvDestroyAllWindows();
  except
    on E: Exception do
      WriteLn(E.ClassName, ': ', E.Message);
  end;
end.
